Developer Documentation

Classes | Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | Private Attributes | Static Private Attributes | List of all members
MaterialPicker Class Reference
Inheritance diagram for MaterialPicker:

## Classes
struct | MaterialInfo

## Public Slots
void | slotMouseEvent (QMouseEvent *_event)
void | slotPickModeChanged (const std::string &_mode)
void | slotKeyEvent (QKeyEvent *_event)
QString | version ()

## Signals
void | addPickMode (const std::string &_mode)
void | updateView ()
void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
void | registerKey (int _key, Qt::KeyboardModifiers _modifiers, QString _description, bool _multiUse=false)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from PickingInterface
virtual void | addPickMode (const std::string &_mode)
| Add a new picking mode to the examiner. More...
Signals inherited from ToolboxInterface
virtual void | addToolbox (QString _name, QWidget *_widget)
| Add a toolbox widget to the gui with the given name. More...
Signals inherited from KeyInterface
virtual void | registerKey (int _key, Qt::KeyboardModifiers _modifiers, QString _description, bool _multiUse=false)
| Register a key-combination for your plugin. More...

## Public Member Functions
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...

## Private Slots
void | initializePlugin ()
void | pluginsInitialized ()
void | slotPickMaterialMode ()
void | slotFillMaterialMode ()
void | slotRemoveCurrentItem ()
void | editMode (QListWidgetItem *_item)
| items can be renamed by double clicking them
void | editModeCurrent ()
void | saveNewName (QWidget *_editor, QAbstractItemDelegate::EndEditHint _hint)
| saves the new material name with hotkey hint
void | saveNewName (QListWidgetItem *_item)
QString | materialString (const MaterialInfo &_mat, const QString &_name)
| returns a formatted string for saving
void | clearList ()
void | removeItem (QListWidgetItem *_item)
void | createContextMenu (const QPoint &_point)
| creates context menu on current item (current is the item at mouse position)
void | changeHotKey (const int _key)
| change specified HotKey to current item
void | slotMaterialProperties ()
void | slotEnableListWidget (int _save)
void | slotMaterialChanged ()
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...
Private Slots inherited from KeyInterface
virtual void | slotKeyEvent (QKeyEvent *_event)
| Key Event from Main App. More...

## Private Member Functions
QString | itemName (const QString &_name, int _key)
| returns the item name with hotkey hint
QString | plainName (const QString &string, int index)
| returns the plain name of the material without hotkey hint
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from MouseInterface
virtual | ~MouseInterface ()
| Destructor.
Private Member Functions inherited from PickingInterface
virtual void | addHiddenPickMode (const std::string &_mode)
| Add a new picking mode to the examiner which will be invisible. More...
virtual void | setPickModeCursor (const std::string &_mode, QCursor _cursor)
| Set the cursor of the given PickMode. More...
virtual void | setPickModeMouseTracking (const std::string &_mode, bool _mouseTracking)
| Set mouse tracking for the given PickMode. More...
virtual void | setPickModeToolbar (const std::string &_mode, QToolBar *_toolbar)
| Set the additional toolbar of the given PickMode. More...
virtual void | removePickModeToolbar (const std::string &_mode)
| Removes the additional toolbar of the given PickMode. More...
virtual | ~PickingInterface ()
| Destructor.
Private Member Functions inherited from ToolboxInterface
virtual | ~ToolboxInterface ()
| Destructor.
virtual void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
| Add a toolbox widget to the gui with the given name and an icon. More...
virtual void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon, QWidget *_headerAreaWidget)
| Add a toolbox widget to the gui with the given name, icon and header area widget. More...
Private Member Functions inherited from KeyInterface
virtual void | slotKeyReleaseEvent (QKeyEvent *_event)
| Key Release Event from Main App. More...
virtual | ~KeyInterface ()
| Destructor.

## Private Attributes
const std::string | pickModeName_
const QString | propName_
QPushButton * | pickMaterialButton_
QPushButton * | fillMaterialButton_
QListWidget * | materialListWidget_
QVector< MaterialInfo > | materialList_
QStringList | materialStrings_
std::map< int, size_t > | shortKeyRow_
ptr::shared_ptr< MaterialNode > | materialNode_
bool | pickMaterial_
| stores the state of the pick material button
bool | fillMaterial_
| stores the state of the fill material button

## Static Private Attributes
static const unsigned | supportedKeys_ = 3

## Detailed Description

Definition at line 62 of file MaterialPicker.hh.

## Member Function Documentation

## ◆ description()

QString MaterialPicker::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 96 of file MaterialPicker.hh.

## ◆ name()

QString MaterialPicker::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 95 of file MaterialPicker.hh.

The documentation for this class was generated from the following files:

- Plugin-MaterialPicker/MaterialPicker.hh
- Plugin-MaterialPicker/MaterialPicker.cc